﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using AddinExpress.RTD;

namespace IntegratedSolutionSample
{
    /// <summary>
    ///   Add-in Express RTD Server Module
    /// </summary>
    [GuidAttribute("65533F26-A3B8-48A9-B32A-AE91DFF20A17"), ProgId("IntegratedSolutionSample.MyRTDServerModule")]
    public class MyRTDServerModule : AddinExpress.RTD.ADXRTDServerModule
    {
        public MyRTDServerModule()
        {
            InitializeComponent();
            // Please add any initialization code to the RTDInitialize event handler
        }

        private ADXRTDTopic adxrtdTopic1;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxrtdTopic1 = new AddinExpress.RTD.ADXRTDTopic(this.components);
            // 
            // adxrtdTopic1
            // 
            this.adxrtdTopic1.String01 = "*";
            this.adxrtdTopic1.String02 = "RandomValue";
            this.adxrtdTopic1.Tag = "";
            this.adxrtdTopic1.RefreshData += new AddinExpress.RTD.ADXRefreshData_EventHandler(this.adxrtdTopic1_RefreshData);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void RTDServerRegister(Type t)
        {
            AddinExpress.RTD.ADXRTDServerModule.ADXRTDServerRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void RTDServerUnregister(Type t)
        {
            AddinExpress.RTD.ADXRTDServerModule.ADXRTDServerUnregister(t);
        }

        #endregion

        public static new MyRTDServerModule CurrentInstance
        {
            get
            {
                return AddinExpress.RTD.ADXRTDServerModule.CurrentInstance as MyRTDServerModule;
            }
        }

        private object adxrtdTopic1_RefreshData(object sender)
        {
            object returnValue;
            Random random = new Random();
            int randomNumber = random.Next(0, 100);

            AddinExpress.RTD.ADXRTDTopic topic = (AddinExpress.RTD.ADXRTDTopic)sender;
            returnValue = String.Format("{0} : {1}", topic.String01, randomNumber);
            return returnValue;
        }
        
    }
}

