﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using AddinExpress.SmartTag;
using System.Diagnostics;

namespace IntegratedSolutionSample
{
    /// <summary>
    ///   Add-in Express Smart Tag Module
    /// </summary>
    [GuidAttribute("217F4846-9372-4796-88E1-39AD5AD04F4D"), ProgId("IntegratedSolutionSample.MySmartTag")]
    public class MySmartTag : AddinExpress.SmartTag.ADXSmartTagModule
    {
        public MySmartTag()
        {
            InitializeComponent();
            populationSmartTagAction.Click += populationSmartTagAction_Click;
            wikipediaSmartTagAction.Click += wikipediaSmartTagAction_Click;
        }

        void wikipediaSmartTagAction_Click(object sender, ADXSmartTagActionEventArgs e)
        {
            Process.Start("http://en.wikipedia.org/wiki/" + e.Text.Replace(" ", "_"));
        }

        void populationSmartTagAction_Click(object sender, ADXSmartTagActionEventArgs e)
        {
            long populationCount = 0;
            switch (e.Text)
            {
                case "Belarus":
                    populationCount = 9648533;
                    break;

                case "Canada":
                    populationCount = 34474000;
                    break;

                case "South Africa":
                    populationCount = 49991300;
                    break;

                case "United States":
                    populationCount = 308745538;
                    break;

                default:
                    break;
            }
            MessageBox.Show(String.Format("Population of {0} is : {1}", e.Text, populationCount));
        }

        private ADXSmartTag adxSmartTag1;
        private ADXSmartTagAction populationSmartTagAction;
        private ADXSmartTagAction wikipediaSmartTagAction;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxSmartTag1 = new AddinExpress.SmartTag.ADXSmartTag(this.components);
            this.populationSmartTagAction = new AddinExpress.SmartTag.ADXSmartTagAction(this.components);
            this.wikipediaSmartTagAction = new AddinExpress.SmartTag.ADXSmartTagAction(this.components);
            // 
            // adxSmartTag1
            // 
            this.adxSmartTag1.Actions.Add(this.populationSmartTagAction);
            this.adxSmartTag1.Actions.Add(this.wikipediaSmartTagAction);
            this.adxSmartTag1.ADXTag = "CountriesSmartTag";
            this.adxSmartTag1.RecognizedWords.AddRange(new string[] {
            "Belarus",
            "Canada",
            "South Africa",
            "United States"});
            this.adxSmartTag1.Caption = new AddinExpress.SmartTag.ADXLocalizedList();
            this.adxSmartTag1.Caption.Add(0, "Countries Smart Tag");
            // 
            // populationSmartTagAction
            // 
            this.populationSmartTagAction.ADXTag = "MySmartTagAction1";
            this.populationSmartTagAction.Caption = new AddinExpress.SmartTag.ADXLocalizedList();
            this.populationSmartTagAction.Caption.Add(0, "Show Population Count");
            // 
            // wikipediaSmartTagAction
            // 
            this.wikipediaSmartTagAction.ADXTag = "MySmartTagAction1";
            this.wikipediaSmartTagAction.Caption = new AddinExpress.SmartTag.ADXLocalizedList();
            this.wikipediaSmartTagAction.Caption.Add(0, "Show Wikipedia Page");
            // 
            // MySmartTag
            // 
            this.NamespaceURI = "integratedsolutionsample/smarttagmodule";
            this.LibraryName = new AddinExpress.SmartTag.ADXLocalizedList();
            this.LibraryName.Add(0, "IntegratedSolutionSample");
            this.Description = new AddinExpress.SmartTag.ADXLocalizedList();
            this.Description.Add(0, "This is a description");

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void SmartTagRegister(Type t)
        {
            AddinExpress.SmartTag.ADXSmartTagModule.ADXSmartTagRegister(t, typeof(IntegratedSolutionSample.MySmartTagRecognizerImpl), typeof(IntegratedSolutionSample.MySmartTagActionImpl));
        }

        [ComUnregisterFunctionAttribute]
        public static void SmartTagUnregister(Type t)
        {
            AddinExpress.SmartTag.ADXSmartTagModule.ADXSmartTagUnregister(t, typeof(IntegratedSolutionSample.MySmartTagRecognizerImpl), typeof(IntegratedSolutionSample.MySmartTagActionImpl));
        }

        #endregion

        public static new MySmartTag CurrentInstance
        {
            get
            {
                return AddinExpress.SmartTag.ADXSmartTagModule.CurrentInstance as MySmartTag;
            }
        }
    }
}

