﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;

namespace IntegratedSolutionSample
{
    /// <summary>
    ///   Add-in Express XLL Add-in Module
    /// </summary>
    [ComVisible(true)]
    public class MyXLLModule : AddinExpress.MSO.ADXXLLModule
    {
        public MyXLLModule()
        {
            InitializeComponent();
            // Please add any initialization code to the OnInitialize event handler
        }

        private ADXExcelFunctionCategory adxExcelFunctionCategory1;
        private ADXExcelFunctionDescriptor adxExcelFunctionDescriptor1;
        private ADXExcelParameterDescriptor adxExcelParameterDescriptor1;
        private ADXExcelParameterDescriptor adxExcelParameterDescriptor2;
        private ADXExcelParameterDescriptor adxExcelParameterDescriptor3;
        private ADXExcelParameterDescriptor adxExcelParameterDescriptor4;
        private ADXExcelParameterDescriptor adxExcelParameterDescriptor5;

        #region Component Designer generated code

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxExcelFunctionCategory1 = new AddinExpress.MSO.ADXExcelFunctionCategory(this.components);
            this.adxExcelFunctionDescriptor1 = new AddinExpress.MSO.ADXExcelFunctionDescriptor(this.components);
            this.adxExcelParameterDescriptor1 = new AddinExpress.MSO.ADXExcelParameterDescriptor(this.components);
            this.adxExcelParameterDescriptor2 = new AddinExpress.MSO.ADXExcelParameterDescriptor(this.components);
            this.adxExcelParameterDescriptor3 = new AddinExpress.MSO.ADXExcelParameterDescriptor(this.components);
            this.adxExcelParameterDescriptor4 = new AddinExpress.MSO.ADXExcelParameterDescriptor(this.components);
            this.adxExcelParameterDescriptor5 = new AddinExpress.MSO.ADXExcelParameterDescriptor(this.components);
            // 
            // adxExcelFunctionCategory1
            // 
            this.adxExcelFunctionCategory1.CategoryName = "GPS Function";
            this.adxExcelFunctionCategory1.FunctionDescriptors.Add(this.adxExcelFunctionDescriptor1);
            // 
            // adxExcelFunctionDescriptor1
            // 
            this.adxExcelFunctionDescriptor1.Description = "Calculates the distance between two longitude and latitude values";
            this.adxExcelFunctionDescriptor1.FunctionName = "Distance";
            this.adxExcelFunctionDescriptor1.ParameterDescriptors.Add(this.adxExcelParameterDescriptor1);
            this.adxExcelFunctionDescriptor1.ParameterDescriptors.Add(this.adxExcelParameterDescriptor2);
            this.adxExcelFunctionDescriptor1.ParameterDescriptors.Add(this.adxExcelParameterDescriptor3);
            this.adxExcelFunctionDescriptor1.ParameterDescriptors.Add(this.adxExcelParameterDescriptor4);
            this.adxExcelFunctionDescriptor1.ParameterDescriptors.Add(this.adxExcelParameterDescriptor5);
            // 
            // adxExcelParameterDescriptor1
            // 
            this.adxExcelParameterDescriptor1.Description = "GPS Location A Latitude";
            this.adxExcelParameterDescriptor1.ParameterName = "latitudeA";
            // 
            // adxExcelParameterDescriptor2
            // 
            this.adxExcelParameterDescriptor2.Description = "GPS Location A Longitude";
            this.adxExcelParameterDescriptor2.ParameterName = "longitudeA";
            // 
            // adxExcelParameterDescriptor3
            // 
            this.adxExcelParameterDescriptor3.Description = "GPS Location B Latitude";
            this.adxExcelParameterDescriptor3.ParameterName = "latitudeB";
            // 
            // adxExcelParameterDescriptor4
            // 
            this.adxExcelParameterDescriptor4.Description = "GPS Location B Longitude";
            this.adxExcelParameterDescriptor4.ParameterName = "longitudeB";
            // 
            // adxExcelParameterDescriptor5
            // 
            this.adxExcelParameterDescriptor5.Description = "Unit of measure(Miles or KM)";
            this.adxExcelParameterDescriptor5.ParameterName = "unit";
            // 
            // MyXLLModule
            // 
            this.AddinName = "MyXLLModule";

        }

        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void RegisterXLL(Type t)
        {
            AddinExpress.MSO.ADXXLLModule.RegisterXLLInternal(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void UnregisterXLL(Type t)
        {
            AddinExpress.MSO.ADXXLLModule.UnregisterXLLInternal(t);
        }

        #endregion

        public static new MyXLLModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXXLLModule.CurrentInstance as MyXLLModule;
            }
        }

        #region Define your UDFs in this section

        /// <summary>
        /// The container for user-defined functions (UDFs). Every UDF is a public static (Public Shared in VB.NET) method that returns a value of any base type: string, double, integer.
        /// </summary>
        internal static class XLLContainer
        {
            /// <summary>
            /// Required by Add-in Express. Please do not modify this method.
            /// </summary>
            internal static MyXLLModule Module
            {
                get
                {
                    return AddinExpress.MSO.ADXXLLModule.
                        CurrentInstance as IntegratedSolutionSample.MyXLLModule;
                }
            }

            #region Sample function

            // Demonstrates how to handle all parameter types available for UDFs.
            // Uncomment the code, click Register Add-in Express Project in the Build menu, and run Excel.

            //public static string AllSupportedExcelTypes(object arg)
            //{
            //    if (arg is double)
            //        return "Double: " + (double)arg;
            //    else if (arg is string)
            //        return "String: " + (string)arg;
            //    else if (arg is bool)
            //        return "Boolean: " + (bool)arg;
            //    else if (arg is AddinExpress.MSO.ADXExcelError)
            //        return "ExcelError: " + arg.ToString();
            //    else if (arg is object[,])
            //        return string.Format("Array[{0},{1}]", ((object[,])arg).GetLength(0), ((object[,])arg).GetLength(1));
            //    else if (arg is System.Reflection.Missing)
            //        return "Missing";
            //    else if (arg == null)
            //        return "Empty";
            //    else if (arg is AddinExpress.MSO.ADXExcelRef)
            //    {
            //        AddinExpress.MSO.ADXExcelRef reference = arg as AddinExpress.MSO.ADXExcelRef;
            //        return string.Format("Reference [{0},{1},{2},{3}]", reference.ColumnFirst, reference.RowFirst, reference.ColumnLast, reference.RowLast);
            //    }
            //    else if (arg is short)
            //        return "Short: " + (short)arg;
            //    else
            //        return "Unknown Type";
            //}

            #endregion

            public static double Distance(double latitudeA, double longitudeA, double latitudeB, double longitudeB, string unit)
            {
                double R = (unit == "Miles") ? 3960 : 6371;
                double dLat = toRadian(latitudeB - latitudeA);
                double dLon = toRadian(longitudeB - longitudeA);
                double a = Math.Sin(dLat / 2) * Math.Sin(dLat / 2) +
                Math.Cos(toRadian(latitudeA)) * Math.Cos(toRadian(latitudeB)) *
                Math.Sin(dLon / 2) * Math.Sin(dLon / 2);
                double c = 2 * Math.Asin(Math.Min(1, Math.Sqrt(a)));
                double d = R * c;

                return d;
            }

            private static double toRadian(double val)
            {
                return (Math.PI / 180) * val;
            }

        }

        #endregion
    }
}

